// Created by Nikolay Budin

#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int x, k;
	cin >> x >> k;
	vector<vector<pll>> rows(k);
	for (int i = 0; i < k; ++i) {
		int q;
		cin >> q;
		auto& arr = rows[i];
		ll cur = 0;
		ll minv = 0;
		for (int j = 0; j < q; ++j) {
			int num;
			cin >> num;
			cur += num;
			minv = min(minv, cur);
			if (cur > 0) {
				arr.push_back({minv, cur});
				minv = cur = 0;
			}
		}
	}

	vector<int> cnt(k);
	set<pair<ll, int>> have;
	for (int i = 0; i < k; ++i) {
		if (szof(rows[i]) > 0) {
			have.insert({rows[i][0].ff, i});
		}
	}

	ll cur = x;
	while (szof(have)) {
		auto it = have.lower_bound({-cur, -1});
		if (it == have.end()) {
			break;
		}
		int ind = it->ss;
		have.erase(it);
		cur += rows[ind][cnt[ind]].ss;
		cnt[ind]++;
		if (cnt[ind] < szof(rows[ind])) {
			have.insert({rows[ind][cnt[ind]].ff, ind});
		}
	}

	cout << cur << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}