#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int INF = (int) 1e9;

int readAns(InStream& in, int b, int n) {
  int a = in.readInt(0, 3, "a");
  if (a == 0) {
    return INF;
  }
  int k = in.readInt(1, 10 * n, "k");
  int p = 1;
  for (int i = 0; i < k; i++) {
    p = (int) ((long long) p * b % n);
  }
  if ((a == 1 && p != 0) || (a == 2 && p != 1) || (a == 3 && p != n - 1)) {
    in.quitf(_wa, "a=%d and k=%d doesn't work", a, k);
  }
  return k;
}

int main(int argc, char* argv[]) {
  registerTestlibCmd(argc, argv);
  int t = inf.readInt();
  for (int q = 1; q <= t; q++) {
    setTestCase(q);
    int b = inf.readInt();
    int n = inf.readInt();
    int jury = readAns(ans, b, n);
    int part = readAns(ouf, b, n);
    if (jury > part) {
      quitf(_fail, "better than author's solution: expected %d, found %d", jury == INF ? 0 : jury, part == INF ? 0 : part);
    }
    if (jury < part) {
      quitf(_wa, "worse than author's solution: expected %d, found %d", jury == INF ? 0 : jury, part == INF ? 0 : part);
    }
  }
  quitf(_ok, "ok");
}
