import kotlin.random.Random
import kotlin.random.nextLong

fun main(args: Array<String>) {
    val rng = Random(args.contentHashCode())
    val pRange = args[0].toRange()
    val qRange = args[1].toRange()
    val p = rng.nextLong(pRange)
    val q = rng.nextLong(qRange)
    println("$p $q")
}

private fun String.toRange(): LongRange {
    if (contains("..")) {
        val (a, b) = split(Regex("\\.\\.")).map { it.toLong() }
        return a..b
    }
    val a = toLong()
    return a..a
}
