// (C) Alice Sayutina 2023

import scala.io.StdIn._

object StupidSolution {
  // this should be as external class
  // however polygon doesn't accept this for some reason.

  class Solution(array: Array[Int]) {
    def increase(l: Int, r: Int): Unit = {
      for (i <- l to r) {
        array(i) += 1
      }
    }

    def prefixMax(array: Array[Int]): Array[Int] = {
      val result = array.clone()
      for (i <- 1 until result.length) {
        result(i) = Math.max(result(i - 1), result(i))
      }

      result
    }

    def solveStupid(): Long = {
      val leftMax = prefixMax(array)
      val rightMax = prefixMax(array.reverse).reverse

      val tmp = (leftMax, rightMax).zipped
      val res = tmp.map(Math.min).map(_.toLong).sum
      res - array.view.map(_.toLong).sum
    }
  }


  def main(args: Array[String]): Unit = {
    val nq = readLine().split(' ').map(Integer.parseInt)
    val q = nq(1)
    val array = readLine().split(' ').map(Integer.parseInt)
    val solution = new Solution(array)

    println(solution.solveStupid())
    for (i <- 1 to q) {
      val lr = readLine().split(' ').map(Integer.parseInt)
      solution.increase(lr(0) - 1, lr(1) - 1)
      println(solution.solveStupid())
    }
  }
}
