#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n;
vector<vector<int>> g;

inline int readAndCheckAnswer(InStream &in) {
    int k = in.readInt(-1, n, "k");
    if (k == -1) return -1;
    vector<bool> used(n);
    vector<vector<int>> cur = g;
    for (int i = 0; i < k; i++) {
        int c = in.readInt(1, n, "c");
        int d = in.readInt(1, n, "d");
        c--; d--;
        if (c == d) {
            in.quitf(_wa, "throw to the same city");
        }
        if (used[c]) {
            in.quitf(_wa, "catapult %d used twice", c + 1);
        }
        used[c] = true;
        for (int x : cur[c]) {
            if (x != d) {
                cur[d].push_back(x);
            }
        }
        cur[c].clear();
    };
    for (int i = 0; i < n; i++) {
        if (!cur[i].empty()) {
            in.quitf(_wa, "passenger wanted to travel to %d, ended up in %d", cur[i][0] + 1, i + 1);
        }
    }
    return k;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    g.resize(n);
    int m = inf.readInt();
    for (int i = 0; i < m; i++) {
        int a, b;
        a = inf.readInt();
        b = inf.readInt();
        a--;
        b--;
        g[a].push_back(b);
    }

    auto ja = readAndCheckAnswer(ans);
    auto pa = readAndCheckAnswer(ouf);

    if (pa == -1 && ja != -1) quitf(_wa, "Not impossible");
    if (pa != -1 && ja == -1) quitf(_fail, "Jury said it's impossible but it's not");
    if (pa > ja) quitf(_wa, "Solution is not optimal: expected %d, found %d", ja, pa);
    if (pa < ja) quitf(_fail, "Jury solution is not optimal: expected %d, found %d", ja, pa);

    quitf(_ok, "");
}
