#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int k = atoi(argv[3]);

    vector<int> p(n);
    for (int i = 0; i < n; i++) p[i] = i;
    shuffle(p.begin(), p.end());

    vector<pair<int, int>> e;
    for (int i = 0; i < n - 1; i++) {
        e.emplace_back(p[i], p[(i + 1) % n]);
    }
    for (int t = 0; t < m - n; t++) {
        int d = rnd.next(1, k);
        int i = rnd.next(0, n - d - 1);
        e.emplace_back(p[i], p[(i + d) % n]);
    }
    shuffle(e.begin(), e.end());

    cout << n << " " << e.size() << "\n";
    for (auto [x, y] : e) {
        cout << x + 1 << " " << y + 1 << "\n";
    }

    return 0;
}