//  ↘ ⬇ ⬇ ⬇ ⬇ ⬇ ↙
//  ➡ @roadfromroi ⬅
//  ↗ ⬆ ⬆ ⬆ ⬆ ⬆ ↖
#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "iomanip"
#include "bitset"
#include "cmath"
#include "map"
#include "deque"
#include "array"
#include "set"
#define all(x) x.begin(), x.end()
#define int long long
using namespace std;

int gcd(int a, int b){
    if (a == 0){
        return b;
    }
    return gcd(b % a, a);
}
int pow(int a, int b, int c) {
    int res = 1;
    while (b) {
        if (b % 2)
            res = res * a % c;
        b /= 2;
        a = a * a % c;
    }
    return res;
}
int solve2(int k, int a, int b) {
    int t = gcd(a, b);
    if (k % t != 0) {
        return 0;
    }
    a /= t;
    b /= t;
    k /= t;
    while (k > 0 and k % b != 0)
        k -= a;
    while (k > 0 and k % a != 0)
        k -= b;
    if (k < 0) {
        return 0;
    }
    return k / (a * b) + 1;
}
int funk(int k, int a, int b, int c) {
    vector <int> phi(17, 0);
    for (int i = 2; i <= 16; ++i){
        for (int j = 1; j < i; ++j){
            if (gcd(i, j) == 1){
                phi[i]++;
            }
        }

    }
    int g = gcd(gcd(a, b), c);
    if (k % g) {
        return 0;
    }
    a /= g;
    b /= g;
    c /= g;
    k /= g;
    int ans = 0;
    if (gcd(a, b) != 1){
        if (gcd(a, c) != 1){
            if (gcd(b, c) != 1){
                vector <int> elems = {a, b, c};
                sort(elems.begin(),elems.end());
                if (elems[0] == 6){
                    a = 2;
                    b = 5;
                    c = 10;
                    k = (k - 10 * (k % 3)) / 3;
                }
                else{
                    a = 4;
                    b = 5;
                    c = 10;
                    k = (k - 10 * (k % 3)) / 3;
                }
            }
            else{
                swap(a, c);
            }
        }
        else{
            swap(b, c);
        }
    }
    for (int r1 = 0; r1 < a; ++r1){
        int z = r1;
        int k_new = k;
        if (a != 1) {
            int y = k * pow(b, phi[a] - 1, a) - c * pow(b, phi[a] - 1, a)  * z;
            y %= a;
            y += a;
            y %= a;
            k_new = (k - (y) * b - (r1) * c) / a;
        }
        int k_new2 = k_new;
        for (int r2 = 0; r2 < b; ++r2){

            if (b != 1) {
                int y = k_new - c * r2;
                y %= b;
                y += b;
                y %= b;
                k_new2 = (k_new - (y) - (r2) * c) / b;
            }
            int k_new3 = k_new2;
            for (int r3 = 0; r3 < c; ++r3){
                if (c!=1){
                    int y = k_new2 - r3;
                    y %= c;
                    y += c;
                    y %= c;
                    k_new3 = (k_new2 - y - r3) / c;
                }

                k_new3 = max(k_new3, (int) -1);
                ans += (k_new3 + 2) * (k_new3 + 1) / 2;
            }
        }
    }
    return ans;
}
int solve3(int k, int a, int b, int c) {
    int res = 0;
    for (int i = 0; i * a <= k; ++i) {
        int k2 = k - i * a;
        res += solve2(k2, b, c);
    }
    return res;
}


void solve() {
    int k, cnt;
    cin >> k >> cnt;
    if (cnt == 1){
        int a;
        cin >> a;
        if (k % a == 0){
            cout << "1\n";
        }
        else{
            cout << "0\n";
        }
    }
    else{
        if (cnt == 2){
            int a, b;
            cin >> a >> b;
            cout << (long long)solve2(k, a, b) << '\n';
            return;
        }
        else{
            int a, b, c;
            cin >> a >> b >> c;
            cout << (long long)funk(k, a,  b, c) << "\n";
        }
    }
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int t;
    cin >> t;
    while (t){
        solve();
        t--;
    }
}
