import java.util.Scanner


fun SolveSingleTest(reader: Scanner): Long {
  var total_limbs = reader.nextInt()
  var num_gen = reader.nextInt()
  if (num_gen == 1) {
    var a = reader.nextInt()
    if (total_limbs % a == 0) {
      return 1
    }
    return 0
  }
  if (num_gen == 2) {
    var a = reader.nextInt()
    var b = reader.nextInt()
    var result = 0;
    for (i: Int in 0..b-1) {
      var left = total_limbs - a * i;
      if (left >= 0 && left % b == 0) {
        result += left / b / a + 1;
      }
    }
    return result.toLong();
  }
  if (num_gen == 3) {
    var a = reader.nextInt()
    var b = reader.nextInt()
    var c = reader.nextInt()
    var result: Long = 0;
    for (i: Int in 0..c-1) {
	  for (j: Int in 0..c-1) {
        var left = total_limbs - a * i - b * j;
        if (left < 0 || left % c != 0) {
          continue;
        }
        left = left / c;
        for (k in 0..b-1) {
          var last_left = left - k * a;
          if (last_left < 0) {
            continue;
          }
          last_left /= b;
          var count = (last_left / a + 1).toLong();
          var l = last_left + 1;
          var r = last_left + 1 - (count - 1) * a;
          result += (r + l) * count / 2;
        }
      }
    }
    return result;
  }
  return -17;
}

fun main() {
  	val reader = Scanner(System.`in`)

    var t = reader.nextInt()
    for (i: Int in 1..t) {
	    println(SolveSingleTest(reader))    
    }
}