#include <cstdint>
#include <iostream>

int64_t SolveSingleTest() {
  int64_t total_limbs;
  int64_t num_gen;
  std::cin >> total_limbs >> num_gen;
  if (num_gen == 1) {
    int64_t a;
    std::cin >> a;
    int64_t result = 0;
    if (total_limbs % a == 0) {
      ++result;
    }
    return result;
  }
  if (num_gen == 2) {
    int64_t a, b;
    std::cin >> a >> b;
    int64_t result = 0;
    for (int64_t i = 0; i <= total_limbs; i += a) {
      if ((total_limbs - i) % b == 0) {
        ++result;
      }
    }
    return result;
  }
  if (num_gen == 3) {
    int64_t a, b, c;
    std::cin >> a >> b >> c;
    if (a == b && a == c && a == 1) {
        return (total_limbs + 1) * (total_limbs + 2) / 2;
    }
    int64_t result = 0;
    for (int64_t i = 0; i <= total_limbs; i += a) {
      for (int64_t j = 0; j <= total_limbs - i; j += b) {
        int64_t left = total_limbs - i - j;
        if (left % c == 0) {
          ++result;
        }
      }
    }
    return result;
  }
  std::cout << "ERROR\n";
  return -17;
}

int main(int argc, char** argv) {
  int t;
  std::cin >> t;
  for (int i = 0; i < t; i++) {
    std::cout << SolveSingleTest() << "\n";
  }
  return 0;
}