///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <complex>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 200005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
// mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());
mt19937 myrand(373);

int n;
int a[N];

int dp[N][4][8][8];
int d[2][2];

int getbit(int mask, int bit) {
  return ((mask >> bit) & 1);
}

bool is_valid_submask(int mask, int bit, int x) {
  if (getbit(mask, bit) != x) return false;
  for (int i = bit + 1; i < 3; i++) {
    if (getbit(mask, i) != 0) {
      return false;
    }
  }
  return true;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> n;

  int one = 0, zero = 0;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    a[i] %= 2;

    if (a[i] == 1) {
      one++;
    } else {
      zero++;
    }
  }

  one = 0;
  zero = 0;
  for (int i = 1; i <= n; i++) {
    if (a[i] == 1) {
      d[0][1] += zero;
      d[0][1] %= mod;
      d[1][1] += one;
      d[1][1] %= mod;

      one++;
    } else {
      d[0][0] += zero;
      d[0][0] %= mod;
      d[1][0] += one;
      d[1][0] %= mod;

      zero++;
    }
  }

  vector <int> validMasks;
  for (int mask = 0; mask < 8; mask++) {
    int sum = 0;
    for (int i = 0; i < 3; i++) {
      sum += getbit(mask, i);
    }
    if (sum % 2 == 0) {
      validMasks.push_back(mask);
    }
  }

  for (int mask = 0; mask < 8; mask++) {
    dp[n + 1][3][mask][mask] = 1;
  }

  for (int i = n; i >= 1; i--) {
    for (int j = 1; j <= 3; j++) {
      int jj = (j == 1) ? 3 : (j - 1);
      for (int submask = 0; submask < 8; submask++) {
        for (int mask = 0; mask < 8; mask++) {
          if (getbit(mask, j - 1) == a[i] && is_valid_submask(submask, j - 1, a[i])) {
            if (a[i] == 0) {
              if (jj != 3) {
                dp[i][j][submask][mask] += dp[i + 1][jj][submask][mask];
                dp[i][j][submask][mask] %= mod;
              } else {
                dp[i][j][submask][mask] += dp[i + 1][jj][mask][mask];
                dp[i][j][submask][mask] %= mod;
              }
            } else {
              if (jj != 3) {
                dp[i][j][submask][mask] += dp[i + 1][jj][submask - (1 << (j - 1))][mask];
                dp[i][j][submask][mask] %= mod;
              } else {
                dp[i][j][submask][mask] += dp[i + 1][jj][mask][mask];
                dp[i][j][submask][mask] %= mod;
              }
            }
          }
        }
      }
    }

    // add previous
    for (int j = 1; j <= 3; j++) {
      for (int h = 0; h < 8; h++) {
        for (int hh = 0; hh < 8; hh++) {
          dp[i][j][h][hh] += dp[i + 1][j][h][hh];
          dp[i][j][h][hh] %= mod;
        }
      }
    }
  }

  int answ = 0;
  for (int validMask: validMasks) {
    for (int h = 0; h < 8; h++) {
      answ += dp[1][1][h][validMask];
      answ %= mod;
      answ += dp[1][2][h][validMask];
      answ %= mod;
      answ += dp[1][3][h][validMask];
      answ %= mod;
    }
  }

  answ = (answ - 4 + mod) % mod;

  for (int validMask: validMasks) {
    if (getbit(validMask, 0) == 1) {
      answ = (answ - one + mod) % mod;
    } else {
      answ = (answ - zero + mod) % mod;
    }
  }

  for (int validMask: validMasks) {
    for (int i = 0; i < 2; i++) {
      for (int j = 0; j < 2; j++) {
        if (getbit(validMask, 1) == i && getbit(validMask, 0) == j) {
          answ = (answ - d[i][j] + mod) % mod;
        }
      }
    }
  }

  cout << answ << endl;
  return 0;
}
