#include <bits/stdc++.h>
#define int long long
using namespace std;
const int MOD = 998244353;

int binpow(int a, int n) {
    if (n == 0)
        return 1;

    int b = binpow(a, n / 2);
    b = (b * b) % MOD;
    if (n & 1)
        b = (b * a) % MOD;

    return b;
}

int rec(int a) {
    return binpow(a, MOD - 2);
}


int cnt_pairs(vector<int>& a, int a1, int a2) {
    int cnt = 0;
    int res = 0;

    for (int i = 0; i < a.size(); ++i) {
        if (a[i] % 2 == a2) {
            res = (res + cnt) % MOD;
        }
        if (a[i] % 2 == a1) {
            cnt++;
        }
    }
    return res;
}

int get_dp(vector<int>& a, vector<int> p) {
    int n = a.size();
    vector<vector<int>> dp(n + 1, vector<int>(3, 0));

    dp[n][0] = dp[n][1] = dp[n][2] = 1;

    for (int i = n; i > 0; --i) {
        for (int j = 0; j < 3; ++j) {
            dp[i - 1][j] = (dp[i - 1][j] + dp[i][j]) % MOD;
            if ((a[i - 1] % 2) == p[2 - j]) {
                dp[i - 1][(j + 1) % 3] = (dp[i - 1][(j + 1) % 3] + dp[i][j]) % MOD;
            }
        }
    }

    int all_seqs = dp[0][0];
    int len0 = 1;
    int len1 = 0;

    for (int i = 0; i < n; ++i) {
        if (a[i] % 2 == p[0]) {
            len1++;
        }
    }

    int len2 = (cnt_pairs(a, p[0], p[1]));

    int kek = ((all_seqs - len0 - len1 - len2) % MOD + MOD) % MOD;

    return kek;
}

int32_t main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<int> a(n);

    for (int i  = 0; i <n; ++i)
        cin >> a[i];

    int bimbam = 0;

    for (int i  = 0; i < 2; ++i) {
        for (int j = 0; j < 2; ++j) {
            for (int k = 0; k < 2; ++k) {
                if ((i + j + k) % 2 == 0) {
                    bimbam = (bimbam + get_dp(a, {i, j, k})) % MOD;
                }
            }
        }
    }

    cout << bimbam;
}
