#include <bits/stdc++.h>
using namespace std;

const int MOD = 998244353;

vector<int> read() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &x : a) cin >> x;
    return a;
}

void add(int &x, int y) {
    x += y;
    if (x >= MOD) x -= MOD;
}

int solve(vector<int> a) {
    int n = a.size();
    vector<vector<vector<int>>> dp(4, vector<vector<int>>(2, vector<int>(2)));
    dp[0][0][0] = 1;
    for (int val : a) {
        auto ndp = dp;
        for (int i = 0; i <= 3; i++) {
            for (int x = 0; x < 2; x++) {
                for (int y = 0; y < 2; y++) {
                    int sum = (x + y + val) % 2;
                    if (sum == 1 && i >= 2) continue;
                    add(ndp[min(3, i + 1)][y][val % 2], dp[i][x][y]);
                }
            }
        }
        dp = ndp;
    }
    int ans = 0;
    for (int x = 0; x < 2; x++) for (int y = 0; y < 2; y++) add(ans, dp[3][x][y]);
    return ans;
}

int main() {
    cout << solve(read()) << endl;
}