#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <functional>

using namespace std;

void solve(int test_ind){
	int n;
	long long x;
	cin >> x >> n;
	vector<vector<int> > v;
	for (int i=0;i<n;++i) {
		int k;
		cin >> k;
		vector<int> line(k);
		for (int &j: line) cin >> j;
		v.push_back(line);
	}
	auto gett = [&](int ind, int start) -> pair<long long, pair<long long, pair<int, int> > > {
		long long sm = 0, mn = 0;
		for (int sz=v[ind].size();start<sz && sm <= 0;) {
			sm += v[ind][start++];
			mn = min(mn, sm);
		}
		return {mn, {sm, {ind, start} }};
	};
	set<pair<long long, pair<long long, pair<int, int> > > > st; // (cost, (gain, (ind, till)))
	for (int i=0;i<n;++i) {
		auto pr = gett(i, 0);
		if (pr.second.first > 0) {
			st.insert(pr);
		}
	}
	while (!st.empty()) {
		auto pr = *st.rbegin();
		st.erase(pr);
		// cerr << x << " " << pr.first << " " << pr.second.first << endl;
		if (pr.first + x < 0) {
			break;
		}
		x += pr.second.first;
		auto prr = gett(pr.second.second.first, pr.second.second.second);
		if (prr.second.first > 0) {
			st.insert(prr);
		}
	}
	cout << x << endl;
}

int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int t=1;
	//cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
