#include "testlib.h"

/**
 * Author: Niyaz Nigmatullin
 *
 */

using namespace std;

int const MAXSUMK = 1'000'000;

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int maxN = opt<int>("maxn", 1'000'000'000);
	int maxK = opt<int>("maxk", 100'000);
	int t = opt<int>("t", 100'000);
	cout << t << '\n';
	int leftSumK = MAXSUMK - t;
	for (int i = 0; i < t; i++) {
		int n = rnd.next(2, maxN);
		int k = rnd.next(1, min(leftSumK + 1, min(maxK, n - 1)));
		cout << n << ' ' << k << '\n';
		leftSumK -= k - 1;
	}
}
