#include "testlib.h"

/**
 * Author: Niyaz Nigmatullin
 *
 */

using namespace std;

int const MAXN = 1'000'000'000;
int const MAXK = 100'000;
int const MAXSUMK = 1'000'000;
int const MAXT = 100'000;

int main(int argc, char **argv) {
	registerValidation(argc, argv);
	int t = inf.readInt(1, MAXT, "t");
	inf.readEoln();
	int sumK = 0;
	for (int i = 0; i < t; i++) {
	    setTestCase(i+1);
		int n = inf.readInt(2, MAXN, "n");
		inf.readSpace();
		int k = inf.readInt(1, min(n - 1, MAXK), "k");
		inf.readEoln();
		sumK += k;
		ensuref(sumK <= MAXSUMK, "The sum of all 'k' exceeded %d", MAXSUMK);
	}
	inf.readEof();
}
