//  ↘ ⬇ ⬇ ⬇ ⬇ ⬇ ↙
//  ➡ @roadfromroi ⬅
//  ↗ ⬆ ⬆ ⬆ ⬆ ⬆ ↖
#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "iomanip"
#include "bitset"
#include "cmath"
#include "map"
#include "deque"
#include "array"
#include "set"
#define all(x) x.begin(), x.end()
#define int long long
using namespace std;
vector <int> f(1e5 + 1);
const int md = 998244353;

int bin_pow(int n, int k){
    if (k == 0){
        return 1;
    }
    if (k % 2 == 0){
        int x = bin_pow(n, k / 2);
        x *= x;
        return x % md;
    }
    return bin_pow(n, k - 1) * n % md;
}


int c(int n, int k){
    return f[n] * bin_pow(f[k], md - 2) % md * bin_pow(f[n - k], md - 2) % md;
}

void solve() {
    int n, k;
    cin >> n >> k;
    int cnt_blocks = k + 1;
    int one = (cnt_blocks - 2) * 2 + 2;
    int r = n % one;
    int cnt = n / one;

    int sm = one * cnt * (cnt - 1) / 2;
    sm += cnt * r;
    if (cnt == 0){
        r -= cnt_blocks;
        cout << sm << " " << c(cnt_blocks - 2, r) << "\n";
        return;
    }
    int ans = 0;
    for (int r1 = 0; r1 <= 1; ++r1){
        for (int r2 = 0; r2 <= 1; ++r2){
            int ost = r - r1 - r2;
            if (ost >= 0){
                for (int j = 0; j <= cnt_blocks - 2 && j * 2 <= ost; ++j){
                    int c1 = c(cnt_blocks - 2, j);
                    if (ost - j * 2 <= cnt_blocks - 2 - j){
                        int c2 = c(cnt_blocks - 2 - j, ost - j * 2);
                        c1 *= c2;
                        c1 %= md;
                        ans += c1;
                        ans %= md;
                    }

                }
            }
        }
    }
    cout << sm <<" " << ans <<"\n";
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int t;
    cin >> t;
    f[0] = 1;
    for (int i = 1; i <= 1e5;++i){
        f[i] = f[i - 1] * i;
        f[i] %= md;
    }
    while (t--) {
        solve();
    }
}
