fun main() {
    val t = readln().toInt()
    val ans = List(t) {
        val (b, n) = readln().split(" ").map { it.toInt() }
        val r = solveDivisionRule(b, n)
        if (r == null) {
            "0"
        } else {
            "${r.a} ${r.k}"
        }
    }
    println(ans.joinToString("\n"))
}

data class DivisionRule(val a: Int, val k: Int)

fun solveDivisionRule(b: Int, n: Int): DivisionRule? {
    val seen = HashSet<Int>()
    var k = 1
    var p = b.mod(n)
    while (seen.add(p)) {
        when (p) {
            0 -> return DivisionRule(1, k)
            n - 1 -> return DivisionRule(3, k)
            1 -> return DivisionRule(2, k)
        }
        k++
        p = (p.toLong() * b).mod(n)
    }
    return null
}