// eval(result) = x, eval(reverse(result)) = 0
fun getX0(x: Long): String {
    require(x % 2L == 0L)
    val half = x / 2
    return when {
        half < 0 -> "0-${-half}-${-half}"
        else     -> "$half+$half-0"
    }
}

fun main() {
    var (p, q) = readln().split(" ").map { it.toLong() }
    var result = ""
    fun append(s: String) {
        if (result != "") {
            result += "+"
        }
        result += s
    }
    if ((p - q) % 2L != 0L) {
        append("21")
        p -= 21;
        q -= 12;
    }
    var add = 0
    while (p % 2L != 0L || p % 10L == 0L || q % 10L == 0L) {
        p--
        q--
        add++
    }
    if (add != 0) {
        append(add.toString())
    }
    append(getX0(p))
    append(getX0(q).reversed())
    println(result)
}


