// Alisa Sayutina (C) 2023

#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int max_n = 200 * 1000;
auto max_q = max_n;

auto maxnum = int(1e9);

int main(int argc, char** argv) {
    registerValidation(argc, argv);
    
    auto n = inf.readInt(1, max_n, "n");
    inf.readSpace();
    auto q = inf.readInt(1, max_q, "q");
    inf.readEoln();

    for (int i = 0; i < n; ++i) {
        if (i)
            inf.readSpace();
        inf.readInt(1, maxnum, "a_" + std::to_string(i+1));
    }
    inf.readEoln();

    for (int i = 0; i < q; ++i) {
        auto li = inf.readInt(1, n, "l_" + std::to_string(i+1));
        inf.readSpace();
        auto ri = inf.readInt(1, n, "r_" + std::to_string(i+1));
        inf.readEoln();
        ensure(li <= ri);
    }
    
    inf.readEof();
    
    return 0;
}
