#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int k = atoi(argv[3]);
    int pr = atoi(argv[4]);

    vector<vector<int>> c(k);
    vector<int> p(n);
    for (int i = 0; i < n; i++) p[i] = i;
    shuffle(p.begin(), p.end());
    for (int i = 0; i < n; i++) {
        int j = (i < 2 * k) ? i / 2 : rnd.next(0, k - 1);
        c[j].push_back(i);
    }

    vector<bool> ex(n);
    for (int i = 0; i < k; i++) {
        int j = rnd.next(0, (int) c[i].size() - 1);
        if (rnd.next(0, 99) < pr) {
            ex[c[i][j]] = true;
        }
    }

    vector<pair<int, int>> e;
    for (int i = 0; i < k; i++) {
        for (int j = 1; j < (int)c[i].size(); j++) {
            int x = c[i][j];
            int y = c[i][rnd.next(0, j - 1)];
            if (rnd.next(0, 1)) swap(x, y);
            e.emplace_back(x, y);
        }
    }

    while (e.size() < m) {
        int i = rnd.next(0, k - 1);
        int x = rnd.any(c[i].begin(), c[i].end());
        int y = rnd.any(c[i].begin(), c[i].end());
        if (x != y) {
            e.emplace_back(x, y);
        }
    }

    shuffle(p.begin(), p.end());
    for (auto &[x, y] : e) {
        if (!ex[x] && !ex[y]) {
            if (p[x] > p[y]) {
                swap(x, y);
            }
        }
    }

    cout << n << " " << e.size() << "\n";
    for (auto [x, y] : e) {
        cout << x + 1 << " " << y + 1 << "\n";
    }

    return 0;
}