///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <complex>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 200005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
// mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());
mt19937 myrand(373);

int n, m;

bool mark[N];
bool used[N];
vector <int> vertices;

vector <int> gg[N], g[N], gr[N];

void dfs(int v) {
  vertices.push_back(v);
  mark[v] = true;
  for (int to: gg[v]) {
    if (mark[to]) continue;
    dfs(to);
  }
}

vector <int> topsort;

void dfs1(int v, int gag) {
  used[v] = true;
  for (int to: g[v]) {
    if (used[to] || to == gag) continue;
    dfs1(to, gag);
  }
  topsort.push_back(v);
}

int cnt = 0;

void dfs2(int v, int gag) {
  ++cnt;
  used[v] = true;
  if (v != gag) {
    for (int to: gr[v]) {
      if (used[to]) continue;
      dfs2(to, gag);
    }
  }
}

vector < pair<int, int> > answ;

bool check(vector <int>& vertices, int gag = -1) {
  topsort.clear();

  for (int v: vertices) used[v] = false;

  for (int v: vertices) {
    if (!used[v]) {
      dfs1(v, gag);
    }
  }

  for (int v: vertices) used[v] = false;
  reverse(topsort.begin(), topsort.end());

  bool flag = true;

  for (int v: topsort) {
    if (used[v]) continue;
    cnt = 0;
    dfs2(v, gag);
    if (cnt > 1) {
      return false;
    }
  }

  for (int i = 1; i < (int)topsort.size(); i++) {
    answ.emplace_back(topsort[i - 1], topsort[i]);
  }

  if (gag != -1) {
    answ.emplace_back(topsort.back(), gag);
  }

  return true;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> n >> m;

  for (int i = 1; i <= m; i++) {
    int a, b;
    cin >> a >> b;
    gg[a].push_back(b);
    gg[b].push_back(a);
    //
    g[a].push_back(b);
    gr[b].push_back(a);
  }

  for (int i = 1; i <= n; i++) {
    if (mark[i]) continue;

    vertices.clear();
    dfs(i);

    if (check(vertices)) {
      continue;
    }

    bool found = false;
    for (int first: vertices) {
      if (check(vertices, first)) {
        found = true;
        break;
      }
    }

    if (!found) {
      cout << -1 << endl;
      return 0;
    }
  }

  cout << (int)answ.size() << endl;
  for (auto& [a, b]: answ) {
    cout << a << " " << b << endl;
  }
  return 0;
}
