//  ↘ ⬇ ⬇ ⬇ ⬇ ⬇ ↙
//  ➡ @roadfromroi ⬅
//  ↗ ⬆ ⬆ ⬆ ⬆ ⬆ ↖
#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "iomanip"
#include "bitset"
#include "cmath"
#include "map"
#include "deque"
#include "array"
#include "set"
#define all(x) x.begin(), x.end()
using namespace std;
int t = 0;
vector<int> seen;
struct dsu {
    vector<int> p;
    vector<int> inforka;
    vector<vector<int>> elel;
    void init(int n) {
        p.assign(n, {});
        inforka.assign(n, -1);
        elel.assign(n, {});
        for (int i = 0; i < p.size(); ++i) {
            p[i] = i;
            elel[i] = {i};
        }
    }
    int getv(int v) {
        if (p[v] == v) return v;
        return p[v] = getv(p[v]);
    }
    int mrg(int a, int b) {
        a = getv(a);
        b = getv(b);
        if (a == b)
            return 0;
        if (elel[a].size() > elel[b].size())
            swap(a, b);
        for (auto i : elel[a])
            elel[b].push_back(i);
        p[a] = b;
        return 1;
    }
    int info(int x) {
        return inforka[getv(x)];
    }
};
vector<vector<int>> g;
int tr = 0;
int bn = 0;
void dfs(vector<int> veca) {
    vector<pair<int, int>> df;
    for (auto x : veca)
        df.push_back({x, 0});
    while (!df.empty()) {
        auto [v, st] = df.back();
        df.pop_back();
        if (st == 0) {
            seen[v] = t;
            df.push_back({v, 1});
            for (auto i : g[v]) {
                if (i == bn)
                    continue;
                if (seen[i] == t) {
                    tr = 1;
                    return;
                }
                if (seen[i] != t + 1) {
                    df.push_back({i, 0});
                }
            }
        } else {
            seen[v] = t + 1;
        }
    }
}
dsu usd;
void sl(int u) {
    int v = usd.getv(u);
    t += 2;
    tr = 0;
    bn = u;
    dfs(usd.elel[v]);
    if (tr == 0)
        usd.inforka[v] = u;
}
void sldd(int v) {
    t += 2;
    tr = 0;
    bn = -1;
    dfs(usd.elel[v]);
    if (tr == 0)
        usd.inforka[v] = g.size();
}
vector<int> exic;
void topsortdfs(int v, vector<int> &vec) {
    if (seen[v] == t)
        return;
    seen[v] = t;
    for (auto i : g[v]) {
        if (exic[i] == 0)
            topsortdfs(i, vec);
    }
    vec.push_back(v);
}
vector<pair<int, int>> edgs;
void topsortcmp(int v) {
    t += 2;
    vector<int> vec;
    for (auto i : usd.elel[v]) {
        if (i != usd.info(v) and seen[i] != t)
            topsortdfs(i, vec);
    }
    if (usd.info(v) != g.size())
        topsortdfs(usd.info(v), vec);
    reverse(all(vec));
    for (int i = 0; i + 1 < vec.size(); ++i) {
        edgs.push_back({vec[i], vec[i + 1]});
    }
    if (usd.info(v) != g.size())
        edgs.push_back({vec.back(), vec[0]});
}
void solve() {
    int n, m;
    cin >> n >> m;
    seen.assign(n, 0);
    g.assign(n, {});
    usd.init(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        g[a].push_back(b);
        usd.mrg(a, b);
    }
    exic.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (usd.getv(i) == i) {
            sldd(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (usd.info(i) == -1) {
            sl(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (usd.info(i) == -1) {
            cout << "-1\n";return;
        }
        if (usd.info(i) != n)
            exic[usd.info(i)] = 1;
    }
    for (int i = 0; i < n; ++i) {
        if (usd.getv(i) == i) {
            topsortcmp(i);
        }
    }
    cout << edgs.size() << '\n';
    for (auto [a, b] : edgs)
        cout << a + 1 << ' ' << b + 1 << '\n';
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    solve();
}
