#include "testlib.h"

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int64_t habitat_count = inf.readInt(1, 1024, "habitat count");
    inf.readEoln();

    for (int64_t i = 0; i < habitat_count; ++i) {
        setTestCase(i + 1);
        inf.readInt(0, 1'000'000'000, "total_limbs");
        inf.readSpace();
        int64_t evaluation_stages = inf.readInt(1, 3, "evolution_stages");
        inf.readSpace();
        inf.readInts(evaluation_stages, 1, 16, "limbs_i");
        inf.readEoln();
    }

    inf.readEof();
}
