#include <cstdint>
#include <iostream>

int64_t SolveSingleTest() {
  int64_t total_limbs;
  int64_t num_gen;
  std::cin >> total_limbs >> num_gen;
  if (num_gen == 1) {
    int64_t a;
    std::cin >> a;
    int64_t result = 0;
    if (total_limbs % a == 0) {
      ++result;
    }
    return result;
  }
  if (num_gen == 2) {
    int64_t a, b;
    std::cin >> a >> b;
    int64_t result = 0;
    for (int64_t i = 0; i < b; ++i) {
      int64_t left = total_limbs - a * i;
      if (left >= 0 && left % b == 0) {
        result += left / b / a + 1;
      }
    }
    return result;
  }
  if (num_gen == 3) {
    int64_t a, b, c;
    std::cin >> a >> b >> c;
    int64_t result = 0;
    for (int64_t i = 0; i < c; ++i) {
      for (int64_t j = 0; j < c; ++j) {
        int64_t left = total_limbs - a * i - b * j;
        if (left < 0 || left % c != 0) {
          continue;
        }
        left = left / c;
        for (int64_t k = 0; k < b; ++k) {
          int64_t last_left = left - k * a;
          if (last_left < 0) {
            continue;
          }
          last_left /= b;
          int64_t count = last_left / a + 1;
          int64_t l = last_left + 1;
          int64_t r = last_left + 1 - (count - 1) * a;
          result += (r + l) * count / 2;
        }
      }
    }
    return result;
  }
  std::cout << "ERROR\n";
  return -17;
}

int main(int argc, char** argv) {
  int t;
  std::cin >> t;
  for (int i = 0; i < t; i++) {
    std::cout << SolveSingleTest() << "\n";
  }
  return 0;
}