fun main() {
    val h = readln().toInt()
    repeat(h) {
        val a = readln().split(" ").map { it.toInt() }
        val (t, s) = a
        val l = a.drop(2)
        check(s == l.size)
        val ans = when(s) {
            1 -> if (t % l[0] == 0) 1L else 0L
            2 -> solveLimbs(t, l[0], l[1])
            3 -> solveLimbs(t, l[0], l[1], l[2])
            else -> error("!!!")
        }
        println(ans)
    }
}

fun solveLimbs(t: Int, a: Int, b: Int): Long {
    var sum = 0L
    for (na in 0..<b) {
        val rem = t - na * a
        if (rem >= 0 && rem % b == 0) {
            val maxna = t / a
            sum += 1 + (maxna - na) / b
        }
    }
    return sum
}

fun solveLimbs(t: Int, a: Int, b: Int, c: Int): Long {
    val mod = a * b * c
    var res = 0L
    for (na in 0..minOf(b * c - 1, t / a)) {
        for (nb in 0..minOf(a * c - 1, (t - na * a) / b)) {
            val rem = t - na * a - nb * b
            if (rem % c != 0) continue
            val nc = (rem / c) % (a * b)
            val x = na * a + nb * b + nc * c
            if (x > t || (t - x) % mod != 0) continue
            val s = (1 + (t - x) / mod).toLong()
            // s + (s - 1) + ... + 1
            // println("$na $nb $nc -> $s (+${s * (s + 1) / 2})")
            res += s * (s + 1) / 2
        }
    }
    return res
}
