// Author: Ivan Kazmenko (gassa@mail.ru)
module solution;
import std;

immutable int mod = 998_244_353;

void add (ref int a, int b)
{
	a += b;
	a -= mod * (a >= mod);
}

void main ()
{
	int n;
	while (readf !(" %s") (n) > 0)
	{
		readln;
		auto a = readln.splitter.map !(to !(int)).array;
		int [2] f0;
		int [2] [2] f1;
		int [2] [2] [2] f2;
		int [2] [2] [2] [2] f3;
		int b = 0;
		f0[b] = 1;
		foreach (i; 0..n)
		{
			b ^= 1;
			f0[b] = f0[!b];
			f1[b] = f1[!b];
			f2[b] = f2[!b];
			f3[b] = f3[!b];
			auto x = a[i] & 1;
			add (f1[b][x], f0[!b]);
			foreach (u; 0..2)
			{
				add (f2[b][u][x], f1[!b][u]);
				foreach (v; 0..2)
				{
					if (!((u + v + x) & 1))
					{
						add (f3[b][u][v][x],
						    f2[!b][u][v]);
						add (f3[b][u][v][x],
						    f3[!b][x][u][v]);
					}
				}
			}
		}

		int res = 0;
		foreach (u; 0..2)
		{
			foreach (v; 0..2)
			{
				int w = u ^ v;
				add (res, f3[b][u][v][w]);
			}
		}
		writeln (res);
	}
}
