#include "testlib.h"

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(2, 200, "n");
    inf.readEoln();
    std::string s = inf.readToken(format("[LO]{%d}", n), "s");
    int loafs = 0, onions = 0;
    for (int i = 0; i < n; ++i)
        if (s[i] == 'L')
            ++loafs;
        else
            ++onions;
    ensuref(loafs > 0, "the number of loafs should be positive");
    ensuref(onions > 0, "the number of onions should be positive");
    inf.readEoln();
    inf.readEof();
}
